#include "menu.h"

static void menu_init_r(struct menuitem *root)
{
struct menuitem *pchild;

    for(pchild = root->childs; !menu_last_sibling(pchild); pchild++) {
        pchild->parent = root;
        menu_init_r(pchild);
    }
}

void menu_init(struct menuitem *root)
{
struct menuitem *p;

    for(p = root; !menu_last_sibling(p); p++)
        menu_init_r(p);
}

struct menuitem* menu_first_sibling(struct menuitem *root, struct menuitem *item)
{
    if(!menu_last_sibling(item))
        return (item->parent ? item->parent->childs : root);
    return 0;
}

struct menuitem* menu_next_sibling(struct menuitem *root, struct menuitem *item)
{
struct menuitem *next_sibling = item + 1;

    if(!menu_last_sibling(item))
        return (next_sibling && next_sibling->name ? next_sibling : 0);
    return 0;
}

struct menuitem* menu_prev_sibling(struct menuitem *root, struct menuitem *item)
{
struct menuitem *prev_sibling = item - 1, *first_sibling = menu_first_sibling(root, item);

    if(first_sibling)
       return (prev_sibling >= first_sibling && prev_sibling->name ? prev_sibling : 0);
    return 0;
}

