#ifndef MENU_H
#define MENU_H

#include <stdio.h>

typedef void (*menuhandler_t)(void *param);

struct menuitem {
    const char *name;
    struct menuitem *parent;
    struct menuitem *childs;
    menuhandler_t handler;
};

#define menu_root(p) ((p) && !((p)->parent))
#define menu_leaf(p) ((p) && !((p)->childs))
#define menu_parent(p) ((p)->parent)
#define menu_first_child(p) ((p)->childs)
#define menu_last_sibling(p) (!(p) || !((p)->name))

void menu_init(struct menuitem *root);
struct menuitem* menu_first_sibling(struct menuitem *root, struct menuitem *item);
struct menuitem* menu_next_sibling(struct menuitem *root, struct menuitem *item);
struct menuitem* menu_prev_sibling(struct menuitem *root, struct menuitem *item);

#endif

